﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace MvcJsonNet.Models
{
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.Runtime.Serialization;
    using System.Web.Mvc;
    using Newtonsoft.Json;

    public class MyClass : VEntity
    {

        [JsonProperty("id")]
        public override long Id { get; set; }

        [JsonProperty("name")]
        public string Name { get; set; }

        [JsonIgnore]
        public string Description { get; set; }

        [JsonProperty("create_time")]
        public DateTime CreateTime { get; set; }

        public IList<SubClass> SubClasses { get; set; }
    }

    public class SubClass : VEntity
    {


        [JsonIgnore]
        public MyClass MyClass { get; set; }

        [JsonProperty("moneyAmount")]
        public double Amount { get; set; }
    }

    [ModelBinder(typeof (JsonNetModelBinder))]
    public abstract class VEntity
    {
        public virtual long Id { get; set; }
    }
}